-- 天选之战战斗UI
checkRequire("Lua_CountDownAnimation");
Lua_TheSelectionFightingWindow = class("Lua_TheSelectionFightingWindow", Lua_FullSizeWindow);
function Lua_TheSelectionFightingWindow:ctor()
	self:superCall("ctor", false, false, 500, false, false, false);

	self.windowName = "Lua_TheSelectionFightingWindow";
	self.skinName = "TheSelectionWarPanel_skin";
end

function Lua_TheSelectionFightingWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.ownMpBar:setBgSacle(1, -1);
	self.ownMpBar:setBarSacle(1, -1);
	self.enemyHpBar:setBgSacle(-1, 1);
	self.enemyHpBar:setBarSacle(-1, 1);
	self.enemyMpBar:setBgSacle(-1, -1);
	self.enemyMpBar:setBarSacle(-1, -1);
	self.enemyHpBar:setBarPosOffset(106, 0);
	self.enemyMpBar:setBarPosOffset(106, 0);

	self.timeObj:SetActive(false);

	self.ownForceNum = Lua_NumberImage.new(self.content);
	self.ownForceNum.prefix = "a_";
	self.ownForceNum.numWidth = 20;
	self.ownForceNum:setDepth(3);
	self.ownForceNum:setLocation(-455, 330.5, 0);

	self.enemyForceNum = Lua_NumberImage.new(self.content);
	self.enemyForceNum.prefix = "a_";
	self.enemyForceNum.numWidth = 20;
	self.enemyForceNum:setDepth(3);
	self.enemyForceNum:setLocation(391, 330.5, 0);

	-- 遮罩，倒计时完去除
	self.blackBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_black_50", 0, 0, 1280, 720);
	self.blackBg.alpha = 0.5;
	self.blackBg:setDepth(10);
	self.blackBg:setEnable(true);
	self.blackBg:addClickFuntion(self, self.onBlackBgClick);
	self.backBtn:addClickFuntion(self, self.onExitBtnClick); -- 离开

	self:addLuaEvent("UPDATA_FIGHT_SCENCES_INFO", self, self.onUpdateFightInfo);
	self:addLuaEvent("UPDATA_STATE_TIME_INFO", self, self.onUpdateFightTimeInfo);
end

-- 更新战斗数据
function Lua_TheSelectionFightingWindow:onUpdateFightInfo()
	-- own
	local theSelectionWarData = DataCenter.theSelectionWarData;
	self.ownLvTxt.text = theSelectionWarData.left_level;
	self.ownNameTxt.text = theSelectionWarData.left_role_name;
	self.ownAreaTxt.text = theSelectionWarData.left_server_name; -- 区名
	self.ownForceNum.num = theSelectionWarData.left_fight_force == nil and 0 or theSelectionWarData.left_fight_force;
	self.ownForceNum:setNumScale(0.7, 0.7);

	local career = theSelectionWarData.left_career;
	local profession = theSelectionWarData.left_profession;
	self.ownCareerLab.text = Lua_ThingDefine.getJobName(career, profession);
	if isHeadReplaceOpen() then
		self:updateOwnHead();
	else
		self.ownHeadIcon:setUrl(Lua_ThingDefine.getHeadIconUrlByCareer(career, profession));
	end
	
	-- enemy
	self.enemyAreaTxt.text = theSelectionWarData.right_server_name; -- 区名
	self.enemyNameTxt.text = theSelectionWarData.right_role_name;
	self.enemyLvTxt.text = theSelectionWarData.right_level;
	self.enemyForceNum.num = theSelectionWarData.right_fight_force == nil and 0 or theSelectionWarData.right_fight_force;
	self.enemyForceNum:setNumScale(0.7, 0.7);

	career = theSelectionWarData.right_career;
	profession = theSelectionWarData.right_profession;
	self.enemyCareerLab.text = Lua_ThingDefine.getJobName(career, profession);
	if isHeadReplaceOpen() then
		self:updateMatchHead();
	else
		self.enemyHeadIcon:setUrl(Lua_ThingDefine.getHeadIconUrlByCareer(career, profession));
	end
	
	-- 显示血量
	local num = theSelectionWarData.left_left_blood;
	local maxNum = theSelectionWarData.left_total_blood;
	self.ownHpBar:setText(num .. "/" .. maxNum);
	self.ownHpBar:setMaxValue(maxNum);
	self.ownHpBar:setValue(num);

	num = theSelectionWarData.left_left_magic;
	maxNum = theSelectionWarData.left_total_magic;
	self.ownMpBar:setText(num .. "/" .. maxNum);
	self.ownMpBar:setMaxValue(maxNum);
	self.ownMpBar:setValue(num);

	num = theSelectionWarData.right_left_blood;
	maxNum = theSelectionWarData.right_total_blood;
	self.enemyHpBar:setText(num .. "/" .. maxNum);
	self.enemyHpBar:setMaxValue(maxNum);
	self.enemyHpBar:setValue(num);

	num = theSelectionWarData.right_left_magic;
	maxNum = theSelectionWarData.right_total_magic;
	self.enemyMpBar:setText(num .. "/" .. maxNum);
	self.enemyMpBar:setMaxValue(maxNum);
	self.enemyMpBar:setValue(num);  
end

function Lua_TheSelectionFightingWindow:updateOwnHead()
	local theSelectionWarData = DataCenter.theSelectionWarData;
	local role_head = theSelectionWarData.left_role_head_name;
	if role_head ~= nil and role_head ~= "" then
		local isDefault = DataCenter.roleData:isDefaultHead(theSelectionWarData.left_career, role_head);
		if isDefault == true then
			self.ownHeadIcon:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom(role_head, 0));
		else
			self.ownHeadIcon:setUrl(role_head, 99, true);
			-- self.ownHeadIcon:setRoundSize(1, 0.5, 0.5, 0.5);--菱形
			self.ownHeadIcon:setRoundSize(0, 0.5, 0.5, 0.25); -- 圆形
			self.ownHeadIcon:SetDimensions(105, 105);
		end
	end
end

function Lua_TheSelectionFightingWindow:updateMatchHead()
	local theSelectionWarData = DataCenter.theSelectionWarData;
	local role_head = theSelectionWarData.right_role_head_name;
	if role_head ~= nil and role_head ~= "" then
		local isDefault = DataCenter.roleData:isDefaultHead(theSelectionWarData.right_career, role_head);
		if isDefault == true then
			self.enemyHeadIcon:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom(role_head, 0));
		else
			self.enemyHeadIcon:setUrl(role_head, 99, true);
			-- self.enemyHeadIcon:setRoundSize(1, 0.5, 0.5, 0.5); -- 菱形
			self.enemyHeadIcon:setRoundSize(0, 0.5, 0.5, 0.25); -- 圆形
			self.enemyHeadIcon:SetDimensions(105, 105);
		end
	end
end

-- 更新战斗数据
function Lua_TheSelectionFightingWindow:onUpdateFightTimeInfo()
	local num = DataCenter.theSelectionWarData.startTime;
	if num ~= nil then
		if num > 0 then
			if GlobalVar.hooking == true then
				DataCenter.hook:stop(true);
			end
			self.timeObj:SetActive(false);
			self.blackBg:setEnable(true);

			if self.countDownAni == nil then
				self.countDownAni = Lua_CountDownAnimation.new(self.content, self, self.addFightEndTimer);
				self.countDownAni:setDepth(10);
			end
			self.countDownAni:playCountDown(num, 1);
		else
			self:addFightEndTimer();
		end
	end
end

function Lua_TheSelectionFightingWindow:addFightEndTimer()
	if DataCenter.theSelectionWarData.startTime ~= 0 then
		return;
	end
	if self.countDownAni ~= nil then
		self.countDownAni:dispose();
		self.countDownAni = nil;
	end
	if GlobalVar.hooking == false then
		DataCenter.hook:start();
	end
	self.timeObj:SetActive(true);
	self.blackBg:setEnable(false);
	
	local num = DataCenter.theSelectionWarData.reduiseTime;
	self.endTimeTxt.text = TimeTransform.getInstance():transSeconds1(num, true);
	if num > 0 then
		self:startTime();
		self:updateTheSelectionEndTime();
	else
		self:endTimer();
	end
end

function Lua_TheSelectionFightingWindow:startTime()
	if self.bEnd ~= true then
		self.bEnd = true;
		Lua_CommonUtil.addTimer("Lua_TheSelectionFightingWindow", 1, self, self.updateTheSelectionEndTime);
	end
end

-- 战斗结束倒计时
function Lua_TheSelectionFightingWindow:updateTheSelectionEndTime()
	local num = DataCenter.theSelectionWarData.reduiseTime;
	if num <= 0 then
		self:endTimer();
	end
	self.endTimeTxt.text = TimeTransform.getInstance():transSeconds1(num, true);
end

function Lua_TheSelectionFightingWindow:endTimer()
	if self.bEnd == true then
		self.bEnd = false;
		Lua_CommonUtil.removeTimer(self, self.updateTheSelectionEndTime);
	end
end

function Lua_TheSelectionFightingWindow:onExitBtnClick(go) -- 离开
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des =LanUtil.getValue(122813), type = 1, subFun = self.ExitBtnClick});
end

function Lua_TheSelectionFightingWindow:ExitBtnClick(go)
	sendMsg(10400902);
	Lua_WindowUtil.openWin("Lua_TheSelectionFightingWindow", WinParam.ACTION_CLOSE);
	-- Lua_WindowUtil.openWin("Lua_TheSelectionWarWindow", WinParam.ACTION_OPEN);
end

function Lua_TheSelectionFightingWindow:onBlackBgClick(go)
end

function Lua_TheSelectionFightingWindow:dispose()
	if self.blackBg ~= nil then
		self.blackBg:dispose();
		self.blackBg = nil;
	end
	if self.countDownAni ~= nil then
		self.countDownAni:dispose();
		self.countDownAni = nil;
	end
	self:endTimer();
	DataCenter.hook:stop(true);

	self:superCall("dispose");
end