-- 功勋奖励
Lua_TheExploiRewardWindow  = class("Lua_TheExploiRewardWindow", Lua_Window);
function Lua_TheExploiRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TheExploiRewardWindow";
	self.skinName = "TheExploitRewardWindow_skin";
end

function Lua_TheExploiRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 878, 430));
	self.dragList:setLocation(0, -5, 0);
	self.dragList:setListCell(Lua_TheExploiRewardCellItem, 115, 878, 1);

	self:addLuaEvent("UPDATA_EXPLOIT_REWARD_INFO", self, self.showTheExploiRewardInfo);
	Lua_ProxyManager.getProxy("Lua_TheSelectionWarProxy"):sExploitRewardList();
end

function Lua_TheExploiRewardWindow:showTheExploiRewardInfo()
	self.showTxt.text = LanUtil.formateStr(LanUtil.getValue(124035), tostring(DataCenter.theSelectionWarData.exploit));
	local arr = DataCenter.theSelectionWarData.exploit_list;
	self.dragList:setLuaArrayData(arr, true);
end

function Lua_TheExploiRewardWindow:dispose()	
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_TheExploiRewardCellItem = class("Lua_TheExploiRewardCellItem", Lua_ListCell);
function Lua_TheExploiRewardCellItem:ctor(p)
	self:superCall("ctor", p, "TheExploitRewardItem_skin");
end

function Lua_TheExploiRewardCellItem:buildShowItem()
	self:superCall("buildShowItem");

    self.rItem = Lua_RewardItem.new(self.content);
    self.rItem:setLayout(100, 80, 6);
    self.rItem:setMaxShow(6);
    self.rItem:setDepth(10);
    self.rItem:setClickWin(true);
    self.rItem:setMouseEnble(true);
    self.rItem:setItemScale(0.8, 0.8);
    self.rItem:setLocation(-390, -15, 0);

	self.getBtn:addClickFuntion(self, self.onButtonClick); -- 开始匹配
end

function Lua_TheExploiRewardCellItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.showTxt.text = LanUtil.formateStr(LanUtil.getValue(124015), tostring(data.exploit));
	if data.is_reward == 0 then -- 0 未完成，1 可领奖，2 已领奖
		self.getBg:setAltas("common_atlas_2", "ui_common_tishi");
		self.getTxt.text = LanUtil.getValue(124016);
		self.getTxt.effectColorStr = Lua_ColorDefine.transColor("6C2E41");
	elseif data.is_reward == 2 then
		self.getBg:setAltas("common_atlas_2", "ui_common_tishi2");
		self.getTxt.text = LanUtil.getValue(124017);
		self.getTxt.effectColorStr = Lua_ColorDefine.transColor("18590D");
	end
	self.rItem:setRewardByArray(data.data);

	self.getBtn:setEnable(data.is_reward == 1);
	self.getBg:setEnable(data.is_reward ~= 1)
	self.getTxt:setEnable(data.is_reward ~= 1)
	self:showRedDot(data.is_reward == 1);
end

function Lua_TheExploiRewardCellItem:showRedDot(val)
	if val then
		if self._redDotIcon == nil then
			self._redDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 425, 5, 0, 0);
			self._redDotIcon:setDepth(10);
		end
		self._redDotIcon:setEnable(true);
	else
		if self._redDotIcon ~= nil then
			self._redDotIcon:setEnable(false);
		end
	end
end

function Lua_TheExploiRewardCellItem:onButtonClick()
	Lua_ProxyManager.getProxy("Lua_TheSelectionWarProxy"):sgetExploitReward(self._data.exploit);
end

function Lua_TheExploiRewardCellItem:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end